searchNodes=[{"doc":"Provides cache and validation for confluent schemas.","ref":"ConfluentSchema.html","title":"ConfluentSchema","type":"module"},{"doc":"Returns a Supervisor.child_spec() for server to periodically fetch and cache Confluent schemas. You can get credentials from Confluent Cloud : Login &gt; Home &gt; Environments. Or you can also spin off your own Confluent Schema Registry server. Options period - Period in milliseconds to update schemas (optional integer, default 5 minutes) debug - Enable debug logs (optional boolean, default false) name - Name of the GenServer and ETS cache, (optional atom) Useful when multiple schema registries are needed . ( default ` ConfluentSchema.Server ` for the GenServer and ` ConfluentSchema.Cache ` for the ETS table ) ConfluentSchemaRegistry options base_url - URL of schema registry (optional, default &quot; http://localhost:8081&quot; ) username - username or api key (optional) password - password or api secret (optional) adapter - Tesla Adapter (optional, default Tesla.Adapter.Hackney ) middleware - List of Tesla middlewares (optional) local - Whether to use local schemas from priv/confluent_schema/*.json (optional, default false ( when set all above options are ignored ) app_name - Name of the application where local schemas are (required only if local is true) Example opts = [ name : :my_custom_registry , period : :timer . minutes ( 5 ) , debug : false , base_url : &quot;http://localhost:8081&quot; , username : &quot;key&quot; , password : &quot;api secret&quot; , adapter : { Tesla.Adapter.Hackney , hackney_opts } , middleware : [ ] ] children = [ { ConfluentSchema , opts } ] Supervisor . start_link ( children , strategy : :one_for_one )","ref":"ConfluentSchema.html#child_spec/1","title":"ConfluentSchema.child_spec/1","type":"function"},{"doc":"Validates the payload against the schema for the given subject. If you need to validate against multiple schema registries, use the cache_name option. Examples iex&gt; ConfluentSchema . validate ( &quot;a string example&quot; , &quot;subject&quot; ) { :ok , &quot;a string example&quot; } iex&gt; ConfluentSchema . validate ( &quot;a string example&quot; , &quot;unknown-subject&quot; ) { :error , :not_found } iex&gt; ConfluentSchema . validate ( 123 , &quot;subject&quot; ) { :error , [ { &quot;Type mismatch. Expected String but got Integer.&quot; , &quot;#&quot; } ] }","ref":"ConfluentSchema.html#validate/3","title":"ConfluentSchema.validate/3","type":"function"},{"doc":"","ref":"ConfluentSchema.html#t:errors/0","title":"ConfluentSchema.errors/0","type":"type"},{"doc":"Cache Confluent schemas on ETS table.","ref":"ConfluentSchema.Cache.html","title":"ConfluentSchema.Cache","type":"module"},{"doc":"Return the cached Confluent schema for a given subject. Raise ArgumentError if cache is not started. Example iex&gt; Cache . start ( ) iex&gt; Cache . set ( &quot;my-subject&quot; , %{ &quot;type&quot; =&gt; &quot;string&quot; } ) iex&gt; Cache . get ( &quot;my-subject&quot; ) { :ok , %{ &quot;type&quot; =&gt; &quot;string&quot; } } iex&gt; Cache . start ( ) iex&gt; Cache . get ( &quot;my-subject&quot; ) { :error , :not_found }","ref":"ConfluentSchema.Cache.html#get/2","title":"ConfluentSchema.Cache.get/2","type":"function"},{"doc":"Cache the Confluent schema for a given subject. Raise ArgumentError if cache is not started. Example iex&gt; Cache . start ( ) iex&gt; Cache . set ( &quot;my-subject&quot; , %{ &quot;type&quot; =&gt; &quot;string&quot; } ) true iex&gt; assert_raise ArgumentError , fn -&gt; Cache . set ( &quot;my-subject&quot; , %{ &quot;type&quot; =&gt; &quot;string&quot; } ) end","ref":"ConfluentSchema.Cache.html#set/3","title":"ConfluentSchema.Cache.set/3","type":"function"},{"doc":"Starts cache for Confluent schemas. Must be called before cache is used. Raise ArgumentError if called more than once. Example iex&gt; Cache . start ( ) :&quot;Elixir.ConfluentSchema.Cache&quot; iex&gt; Cache . start ( ) iex&gt; assert_raise ArgumentError , fn -&gt; Cache . start ( ) end","ref":"ConfluentSchema.Cache.html#start/1","title":"ConfluentSchema.Cache.start/1","type":"function"},{"doc":"Http interface for Confluent Schema.","ref":"ConfluentSchema.Registry.html","title":"ConfluentSchema.Registry","type":"module"},{"doc":"Creates a client to interact with Confluent Schema Registry.","ref":"ConfluentSchema.Registry.html#create/1","title":"ConfluentSchema.Registry.create/1","type":"function"},{"doc":"Get the latest Confluent schemas from the server. Decode the JSON schemas into maps. Examples iex&gt; client = RegistryMock . create ( ) iex&gt; Registry . get_subject_schemas ( client ) { :ok , %{ &quot;foo&quot; =&gt; %{ &quot;type&quot; =&gt; &quot;string&quot; } , &quot;bar&quot; =&gt; %{ &quot;type&quot; =&gt; &quot;string&quot; } } } iex&gt; client = RegistryMock . create_error_subject ( ) iex&gt; Registry . get_subject_schemas ( client ) { :error , :get_subjects , 404 , &quot;Not Found&quot; } iex&gt; client = RegistryMock . create_error_schema ( ) iex&gt; Registry . get_subject_schemas ( client ) { :error , :get_schema , 404 , &quot;Not Found&quot; } iex&gt; client = RegistryMock . create_error_decode ( ) iex&gt; Registry . get_subject_schemas ( client ) { :error , :decode_schema , 1 , % Jason.DecodeError { position : 0 , token : nil , data : &quot;invalid json&quot; } }","ref":"ConfluentSchema.Registry.html#get_subject_schemas/1","title":"ConfluentSchema.Registry.get_subject_schemas/1","type":"function"},{"doc":"Server to periodically fetch and cache the latest Confluent schemas.","ref":"ConfluentSchema.Server.html","title":"ConfluentSchema.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ConfluentSchema.Server.html#child_spec/1","title":"ConfluentSchema.Server.child_spec/1","type":"function"},{"doc":"Starts the server","ref":"ConfluentSchema.Server.html#start_link/1","title":"ConfluentSchema.Server.start_link/1","type":"function"},{"doc":"Manually update cache","ref":"ConfluentSchema.Server.html#update/0","title":"ConfluentSchema.Server.update/0","type":"function"},{"doc":"Provides cache and validation for confluent schemas that are pulled from a registry. It mixes ConfluentSchemaRegistry ExJsonSchema ETS To provide fast validation for schemas registered remotely on a registry server, for example confluent.cloud .","ref":"readme.html","title":"ConfluentSchema","type":"extras"},{"doc":"def deps do [ { :confluent_schema , &quot;~&gt; 0.1.2&quot; } ] end","ref":"readme.html#installation","title":"ConfluentSchema - Installation","type":"extras"},{"doc":"On application.ex : def start ( _type , _args ) do opts = [ period : :timer . seconds ( 10 ) , debug : true , base_url : &quot;https://foobar.region.aws.confluent.cloud&quot; , username : &quot;key&quot; , password : &quot;api secret&quot; , ] children = [ { ConfluentSchema , opts } ] supervisor_opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , supervisor_opts ) end Then you can use confluent schema registry to validate payloads for a subject: payload = %{ foo : &quot;bar&quot; } ConfluentSchema . validate ( payload , &quot;my-subject&quot; ) Check out ConfluentSchema.child_spec/1 for documentation about all options.","ref":"readme.html#usage","title":"ConfluentSchema - Usage","type":"extras"},{"doc":"On test or dev environment, it is common to not have internet access. In this case, we want to load the schemas from local files. To achieve this, place subject_name.json files inside priv/confluent_schema/ and configure your application like this: # application.ex children = [ { ConfluentSchema , Application . fetch_env! ( :my_app , :confluent_schema ) } ] # config.exs config :my_app , :confluent_schema , local : true , app_name : :my_app # runtime.exs config :naboo , :confluent_schema , base_url : System . fetch_env! ( &quot;CONFLUENT_SCHEMA_REGISTRY_URL&quot; ) , username : System . fetch_env! ( &quot;CONFLUENT_SCHEMA_REGISTRY_API_KEY&quot; ) , password : System . fetch_env! ( &quot;CONFLUENT_SCHEMA_REGISTRY_API_SECRET&quot; ) Now, when ConfluentSchema starts, it will load the schemas from your app's priv/confluent_schema/ directory, on dev and test environment.","ref":"readme.html#test","title":"ConfluentSchema - Test","type":"extras"}]